#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/export-internal.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

#ifdef CONFIG_UNWINDER_ORC
#include <asm/orc_header.h>
ORC_HEADER;
#endif

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif

SYMBOL_CRC(nf_nat_setup_info, 0xedaec824, "");
SYMBOL_CRC(nf_ct_nat_ext_add, 0x3705fd9d, "_gpl");
SYMBOL_CRC(nf_nat_alloc_null_binding, 0x79c365fe, "_gpl");
SYMBOL_CRC(nf_nat_inet_fn, 0x2a586bbd, "_gpl");
SYMBOL_CRC(nf_nat_packet, 0x2553ac40, "_gpl");
SYMBOL_CRC(nf_nat_icmp_reply_translation, 0x995ff171, "_gpl");
SYMBOL_CRC(nf_nat_icmpv6_reply_translation, 0x86ef9df6, "_gpl");
SYMBOL_CRC(nf_nat_inet_register_fn, 0xce0d946d, "_gpl");
SYMBOL_CRC(nf_nat_inet_unregister_fn, 0x08208217, "_gpl");
SYMBOL_CRC(nf_nat_ipv4_register_fn, 0xa6f74162, "_gpl");
SYMBOL_CRC(nf_nat_ipv4_unregister_fn, 0x7901d079, "_gpl");
SYMBOL_CRC(nf_nat_ipv6_register_fn, 0x50d9e7e9, "_gpl");
SYMBOL_CRC(nf_nat_ipv6_unregister_fn, 0x9ec3610a, "_gpl");
SYMBOL_CRC(__nf_nat_mangle_tcp_packet, 0x2575595c, "");
SYMBOL_CRC(nf_nat_follow_master, 0x40093803, "");
SYMBOL_CRC(nf_nat_mangle_udp_packet, 0xfb2d89a6, "");
SYMBOL_CRC(nf_nat_exp_find_port, 0xdba01b56, "_gpl");
SYMBOL_CRC(nf_nat_redirect_ipv4, 0x0455269b, "_gpl");
SYMBOL_CRC(nf_nat_redirect_ipv6, 0x900ddef7, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_inet_register_notifiers, 0x3bc17c49, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_inet_unregister_notifiers, 0xd9c25654, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_ipv4, 0xfd448611, "_gpl");
SYMBOL_CRC(nf_nat_masquerade_ipv6, 0xdd3acd48, "_gpl");
SYMBOL_CRC(nf_ct_nat, 0x551fffd7, "_gpl");

MODULE_INFO(supported, "yes");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0x29481784, "nf_ct_ext_add" },
	{ 0x9259727b, "__do_once_done" },
	{ 0xc2e4c1e7, "try_module_get" },
	{ 0xa8a04cf4, "nf_ip6_checksum" },
	{ 0x31e3c0f2, "skb_copy_bits" },
	{ 0xac5a6926, "nf_hook_entries_insert_raw" },
	{ 0x76cbf326, "xfrm_lookup" },
	{ 0xfba7a5f5, "__get_random_u32_below" },
	{ 0x989bc886, "nf_ct_seqadj_set" },
	{ 0x1408eade, "skb_put" },
	{ 0xa3a5be95, "memmove" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x6e8e6cb3, "nf_ct_helper_expectfn_unregister" },
	{ 0x58bf2955, "__xfrm_decode_session" },
	{ 0x89d99ee1, "__nf_ct_ext_find" },
	{ 0x60f25269, "nf_ct_helper_expectfn_register" },
	{ 0x236c8c64, "memcpy" },
	{ 0x37a0cba, "kfree" },
	{ 0x44f0ad9, "get_random_u16" },
	{ 0x2f6884e5, "ip6_route_me_harder" },
	{ 0x575063f8, "pskb_expand_head" },
	{ 0xb9b799a9, "register_pernet_subsys" },
	{ 0x80d82b34, "nf_conntrack_tuple_taken" },
	{ 0x92997ed8, "_printk" },
	{ 0xe36e4b2f, "nf_ct_iterate_cleanup_net" },
	{ 0x296695f, "refcount_warn_saturate" },
	{ 0x8f082687, "ipv6_skip_exthdr" },
	{ 0x626edd8, "nf_register_net_hooks" },
	{ 0xfe029963, "unregister_inetaddr_notifier" },
	{ 0xe80a5b05, "module_put" },
	{ 0x37feb854, "ipv6_dev_get_saddr" },
	{ 0x33338211, "rcuref_get_slowpath" },
	{ 0x6e2da197, "arch_read_lock_wait" },
	{ 0x8ffe7e89, "nf_conntrack_htable_size" },
	{ 0x79773647, "nf_ct_expect_related_report" },
	{ 0x99a84070, "nf_conntrack_alter_reply" },
	{ 0xa36b685e, "ip_route_me_harder" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0x79408a95, "nf_hook_entries_delete_raw" },
	{ 0x1f6cb011, "skb_ensure_writable" },
	{ 0xbee8417a, "nf_unregister_net_hooks" },
	{ 0x1a97849c, "inet_select_addr" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0x460ec0f, "nf_ct_invert_tuple" },
	{ 0x46847201, "unregister_pernet_subsys" },
	{ 0x47e85940, "skb_checksum" },
	{ 0x2fe252cc, "unregister_inet6addr_notifier" },
	{ 0xf1db1704, "nla_memcpy" },
	{ 0x8820dac2, "nf_ip_checksum" },
	{ 0xaafc181, "register_btf_kfunc_id_set" },
	{ 0xc5911d86, "nf_ct_iterate_destroy" },
	{ 0x2014a246, "__siphash_unaligned" },
	{ 0x42206c16, "inet_proto_csum_replace16" },
	{ 0x9d0d6206, "unregister_netdevice_notifier" },
	{ 0x2e2bb394, "__put_net" },
	{ 0xb15b4109, "crc32c" },
	{ 0x44c10a52, "kvfree_call_rcu" },
	{ 0x67431b0, "__skb_checksum" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0x11a3298c, "inet_proto_csum_replace4" },
	{ 0xe35fb609, "kmemdup" },
	{ 0x60352082, "register_inet6addr_notifier" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0xd2da1048, "register_netdevice_notifier" },
	{ 0xf79faab3, "ip_send_check" },
	{ 0xeab96eca, "dst_release" },
	{ 0xbfe1053e, "nf_ct_kill_acct" },
	{ 0x289c3714, "nf_ct_alloc_hashtable" },
	{ 0xc6d2a983, "nf_nat_hook" },
	{ 0x8676db46, "get_random_bytes" },
	{ 0xf68285c0, "register_inetaddr_notifier" },
	{ 0xf9364cc3, "kmalloc_trace" },
	{ 0x83f51840, "__nla_parse" },
	{ 0x7aa1756e, "kvfree" },
	{ 0x3832522f, "__crc32c_le_shift" },
	{ 0x34297979, "kmalloc_caches" },
	{ 0x18e60984, "__do_once_start" },
	{ 0x2d3385d3, "system_wq" },
	{ 0x609f1c7e, "synchronize_net" },
	{ 0x44e37ce2, "module_layout" },
};

MODULE_INFO(depends, "nf_conntrack,libcrc32c");


MODULE_INFO(srcversion, "413A558B3FA61FE6D06DB72");

MODULE_INFO(suserelease, "SLFO-1.0");
