#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/export-internal.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

#ifdef CONFIG_UNWINDER_ORC
#include <asm/orc_header.h>
ORC_HEADER;
#endif

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif


MODULE_INFO(supported, "yes");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0x965f17ab, "phy_drivers_register" },
	{ 0x156088e5, "mdiobus_read" },
	{ 0x9f0a5a38, "phy_modify" },
	{ 0xb27a17b2, "genphy_soft_reset" },
	{ 0xb1a4a144, "phy_write_paged" },
	{ 0xc9511e26, "_dev_warn" },
	{ 0xf5811a4e, "phy_modify_paged" },
	{ 0xf9a482f9, "msleep" },
	{ 0x86f03f3a, "phy_read_paged" },
	{ 0xf5c0c35f, "__mdiobus_read" },
	{ 0x3850200a, "__mdiobus_write" },
	{ 0x69737b69, "ethnl_cable_test_pulse" },
	{ 0xfc9d6015, "ethnl_cable_test_step" },
	{ 0x807d3505, "phy_select_page" },
	{ 0xec1147aa, "__phy_modify" },
	{ 0xc44bc25e, "phy_restore_page" },
	{ 0xff684bf6, "sfp_parse_support" },
	{ 0x3e411ace, "sfp_select_interface" },
	{ 0x362134ef, "_dev_info" },
	{ 0x8e6ebf48, "_dev_err" },
	{ 0xbf729f5d, "phy_save_page" },
	{ 0x11821712, "phy_trigger_machine" },
	{ 0xe158d224, "phy_error" },
	{ 0xb39285f3, "devm_kmalloc" },
	{ 0xb0544cab, "phy_drivers_unregister" },
	{ 0x7f9214e5, "mdiobus_write" },
	{ 0x3b3e0906, "genphy_c45_ethtool_get_eee" },
	{ 0x95877374, "phy_config_aneg" },
	{ 0xffd474e3, "genphy_read_lpa" },
	{ 0x70abc2d7, "phy_resolve_aneg_pause" },
	{ 0x5041b97a, "genphy_update_link" },
	{ 0xe16822b5, "genphy_read_status_fixed" },
	{ 0xbdafbfaf, "phy_sfp_probe" },
	{ 0xa31a5cc3, "genphy_resume" },
	{ 0x5a3f0e3a, "genphy_suspend" },
	{ 0xb99b68dd, "phy_modify_changed" },
	{ 0x97116c56, "__genphy_config_aneg" },
	{ 0xa4e188e7, "strscpy" },
	{ 0xeca957d1, "__bitmap_and" },
	{ 0xebc555e3, "genphy_check_and_restart_aneg" },
	{ 0x49c44e5a, "genphy_setup_forced" },
	{ 0x3badb606, "phy_modify_paged_changed" },
	{ 0xc3055d20, "usleep_range_state" },
	{ 0x318d4d84, "genphy_read_abilities" },
	{ 0xa084749a, "__bitmap_or" },
	{ 0xa4b1405d, "ethnl_cable_test_result" },
	{ 0xc02b60fe, "ethnl_cable_test_fault_length" },
	{ 0x116348f6, "ethnl_cable_test_amplitude" },
	{ 0x9b16e4ee, "phy_gbit_fibre_features" },
	{ 0x394a1e11, "phy_sfp_attach" },
	{ 0xb6acaa13, "phy_sfp_detach" },
	{ 0x44e37ce2, "module_layout" },
};

MODULE_INFO(depends, "libphy");

MODULE_ALIAS("mdio:0000000101000001000011000110????");
MODULE_ALIAS("mdio:0000000101000001000011001001????");
MODULE_ALIAS("mdio:0000000101000001000011001100????");
MODULE_ALIAS("mdio:0000000111111111000011001100????");
MODULE_ALIAS("mdio:0000000101000001000011100001????");
MODULE_ALIAS("mdio:0000000101000001000011001011????");
MODULE_ALIAS("mdio:0000000101000001000011001101????");
MODULE_ALIAS("mdio:0000000101000001000011100101????");
MODULE_ALIAS("mdio:0000000101000001000011100011????");
MODULE_ALIAS("mdio:0000000101000001000011101001????");
MODULE_ALIAS("mdio:0000000101000001000011100100????");
MODULE_ALIAS("mdio:0000000101000001000011011101????");
MODULE_ALIAS("mdio:0000000101000001000011101011????");
MODULE_ALIAS("mdio:0000000101000001000011101010????");
MODULE_ALIAS("mdio:0000000101000001000011100110????");
MODULE_ALIAS("mdio:0000000101000001000011110100????");
MODULE_ALIAS("mdio:0000000101000001000011111001????");
MODULE_ALIAS("mdio:0000000000101011000010111001????");
MODULE_ALIAS("mdio:0000000101000001000011011100????");
MODULE_ALIAS("mdio:0000000101000001000011101100????");

MODULE_INFO(srcversion, "705C4AA35931A05422E2AE0");

MODULE_INFO(suserelease, "SLFO-1.0");
