#include <linux/module.h>
#define INCLUDE_VERMAGIC
#include <linux/build-salt.h>
#include <linux/elfnote-lto.h>
#include <linux/export-internal.h>
#include <linux/vermagic.h>
#include <linux/compiler.h>

#ifdef CONFIG_UNWINDER_ORC
#include <asm/orc_header.h>
ORC_HEADER;
#endif

BUILD_SALT;
BUILD_LTO_INFO;

MODULE_INFO(vermagic, VERMAGIC_STRING);
MODULE_INFO(name, KBUILD_MODNAME);

__visible struct module __this_module
__section(".gnu.linkonce.this_module") = {
	.name = KBUILD_MODNAME,
	.init = init_module,
#ifdef CONFIG_MODULE_UNLOAD
	.exit = cleanup_module,
#endif
	.arch = MODULE_ARCH_INIT,
};

MODULE_INFO(intree, "Y");

#ifdef CONFIG_RETPOLINE
MODULE_INFO(retpoline, "Y");
#endif


MODULE_INFO(supported, "yes");

static const struct modversion_info ____versions[]
__used __section("__versions") = {
	{ 0x4a4c4764, "crypto_alloc_ahash" },
	{ 0x78569adf, "ida_alloc_range" },
	{ 0x974f3244, "vmemmap" },
	{ 0x49cd25ed, "alloc_workqueue" },
	{ 0xb381ff9e, "ida_destroy" },
	{ 0xbead7ddb, "tls_alert_recv" },
	{ 0x63f85ae6, "ip_sock_set_tos" },
	{ 0xd2504a8c, "arch_spin_lock_wait" },
	{ 0xc5b6f236, "queue_work_on" },
	{ 0x6644f6f6, "nvmet_req_complete" },
	{ 0xc9d64f25, "kernel_bind" },
	{ 0x5ed37557, "sock_create" },
	{ 0x1f913d0, "tls_server_hello_psk" },
	{ 0x5537201c, "tls_handshake_cancel" },
	{ 0xfbc3aeb6, "tls_get_record_type" },
	{ 0x37a0cba, "kfree" },
	{ 0xb320cc0e, "sg_init_one" },
	{ 0xff1ffd2c, "__tracepoint_sk_data_ready" },
	{ 0xa875572c, "kernel_accept" },
	{ 0xc8b099bd, "kernel_recvmsg" },
	{ 0xe0d72af, "sock_alloc_file" },
	{ 0xf7cb4502, "sock_set_priority" },
	{ 0x21f21ab9, "crypto_destroy_tfm" },
	{ 0x808a7971, "nvmet_sq_destroy" },
	{ 0x20592c6f, "arch_write_lock_wait" },
	{ 0x92997ed8, "_printk" },
	{ 0x88e1d0f0, "page_frag_free" },
	{ 0x296695f, "refcount_warn_saturate" },
	{ 0xb2fcb56d, "queue_delayed_work_on" },
	{ 0x3a13f54a, "sgl_alloc" },
	{ 0xb2286aea, "nvmet_unregister_transport" },
	{ 0x2de125c0, "page_frag_alloc_align" },
	{ 0xc73edb82, "nvmet_req_init" },
	{ 0xbcb36fe4, "hugetlb_optimize_vmemmap_key" },
	{ 0x6e2da197, "arch_read_lock_wait" },
	{ 0xeff2f1c5, "fput" },
	{ 0xf2bb6e44, "__traceiter_sk_data_ready" },
	{ 0xc0c98d73, "init_net" },
	{ 0x8c8569cb, "kstrtoint" },
	{ 0x9dc44b42, "kernel_getpeername" },
	{ 0xd92df69e, "kernel_getsockname" },
	{ 0xf1969a8e, "__usecs_to_jiffies" },
	{ 0xd6c881a5, "kernel_sock_shutdown" },
	{ 0x8c03d20c, "destroy_workqueue" },
	{ 0x860efa2c, "mutex_lock" },
	{ 0x73743d06, "nvmet_register_transport" },
	{ 0xd0760fc0, "kfree_sensitive" },
	{ 0xf9a06e0e, "ida_free" },
	{ 0x7f2238b9, "inet_pton_with_scope" },
	{ 0x35b173b7, "sock_sendmsg" },
	{ 0x564405cb, "__cpu_online_mask" },
	{ 0x3c3fce39, "__local_bh_enable_ip" },
	{ 0x1049be79, "sock_set_reuseaddr" },
	{ 0xa0731e8b, "iov_iter_bvec" },
	{ 0x9166fc03, "__flush_workqueue" },
	{ 0xed5fa608, "crypto_ahash_digest" },
	{ 0xe798236d, "jiffies" },
	{ 0x7090dea6, "__page_frag_cache_drain" },
	{ 0x3c3ff9fd, "sprintf" },
	{ 0x5d99a2cd, "kernel_listen" },
	{ 0x86a8fb71, "mutex_unlock" },
	{ 0x9fa7184a, "cancel_delayed_work_sync" },
	{ 0xc6f46339, "init_timer_key" },
	{ 0x24592b12, "nvmet_sq_init" },
	{ 0x87b8798d, "sg_next" },
	{ 0x2cf56265, "__dynamic_pr_debug" },
	{ 0x3c12dfe, "cancel_work_sync" },
	{ 0xb6892de9, "sock_recvmsg" },
	{ 0xffeedf6a, "delayed_work_timer_fn" },
	{ 0x2c09c3a3, "sock_release" },
	{ 0x4a053d24, "tcp_sock_set_nodelay" },
	{ 0xb5e73f30, "nvmet_ctrl_fatal_error" },
	{ 0x4f0f00e8, "nvmet_req_uninit" },
	{ 0xf9364cc3, "kmalloc_trace" },
	{ 0xc7a1840e, "llist_add_batch" },
	{ 0x4fed210b, "param_ops_int" },
	{ 0xdd441ac, "param_get_int" },
	{ 0xaa8f1b71, "inet_addr_is_any" },
	{ 0xa7b5d68, "kernel_sendmsg" },
	{ 0x840342c6, "sgl_free" },
	{ 0x3e0ef07a, "nvmet_wq" },
	{ 0x1dadd920, "__kmalloc" },
	{ 0x34297979, "kmalloc_caches" },
	{ 0x745fc473, "sock_no_linger" },
	{ 0x44e37ce2, "module_layout" },
};

MODULE_INFO(depends, "nvmet");


MODULE_INFO(srcversion, "8F66D75FBCEA1C682BD7ADF");

MODULE_INFO(suserelease, "SLFO-1.0");
